package com.fp.persistence.pgeneral.receive;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TRECEIVABLETEMPLATEDETAIL*/
@Embeddable
public class TreceivableTemplateDetailKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="TEMPLATECODE", nullable=false,updatable=false)

/**
* Código de plantilla de cuentas por cobrar. 
*/
private Integer templatecode;

@Column(name="COMPANYCODE", nullable=false,updatable=false)

/**
* Codigo de compania
*/
private Integer companycode;

/**Contructor por defecto*/
public TreceivableTemplateDetailKey(){}
/**Contructor de TreceivableTemplateDetailKey
@param pTemplatecode Código de plantilla de cuentas por cobrar. 
@param pCompanycode Codigo de compania
*/
public TreceivableTemplateDetailKey(Integer pTemplatecode,Integer pCompanycode){
 templatecode=pTemplatecode;
 companycode=pCompanycode;
}
/**Obtiene el valor de templatecode
@return valor de templatecode*/
public Integer getTemplatecode(){
  return templatecode;
}
/**Fija el valor de templatecode
@param pTemplatecode nuevo Valor de templatecode*/
public void setTemplatecode(Integer pTemplatecode){
  templatecode=pTemplatecode;
}

/**Obtiene el valor de companycode
@return valor de companycode*/
public Integer getCompanycode(){
  return companycode;
}
/**Fija el valor de companycode
@param pCompanycode nuevo Valor de companycode*/
public void setCompanycode(Integer pCompanycode){
  companycode=pCompanycode;
}

/**Implementación de la comparación de TreceivableTemplateDetailKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TreceivableTemplateDetailKey))return false;
  TreceivableTemplateDetailKey that = (TreceivableTemplateDetailKey) o;
  if (this.getTemplatecode() == null || that.getTemplatecode() == null){
      return false;
  }
  if (! this.getTemplatecode().equals(that.getTemplatecode())){
    return false;
  }
  if (this.getCompanycode() == null || that.getCompanycode() == null){
      return false;
  }
  if (! this.getCompanycode().equals(that.getCompanycode())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TreceivableTemplateDetailKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getTemplatecode() == null ? 0 : this.getTemplatecode().hashCode());
    result = result * 37 + (this.getCompanycode() == null ? 0 : this.getCompanycode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
